/*
  File autogenerated by gengetopt version 2.10
  generated with the following command:
  /usr/bin/gengetopt -u -i options.ggo -f options -F options 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "getopt.h"

#include "options.h"

void
options_print_version (void)
{
  printf ("%s %s\n", OPTIONS_PACKAGE, OPTIONS_VERSION);
}

void
options_print_help (void)
{
  options_print_version ();
  printf("\n"
  "Purpose:\n"
  "  print summary information on GMT colour palette\n"
  "\n"
  "Usage: %s [OPTIONS]... [FILES]...\n", OPTIONS_PACKAGE);
  printf("   -h         --help           Print help and exit\n");
  printf("   -V         --version        Print version and exit\n");
  printf("   -c         --csv            output in comma separated value format (default=off)\n");
  printf("   -d         --debug          scan-trace debugging (default=off)\n");
  printf("   -H         --html           output in html format (default=off)\n");
  printf("   -oSTRING   --output=STRING  output filename\n");
  printf("   -p         --plain          output in plain format (default=off)\n");
  printf("   -v         --verbose        verbose operation (default=off)\n");
}


static char *gengetopt_strdup (const char *s);

/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
options (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  int c;	/* Character of the parsed option.  */
  int missing_required_options = 0;

  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->csv_given = 0 ;
  args_info->debug_given = 0 ;
  args_info->html_given = 0 ;
  args_info->output_given = 0 ;
  args_info->plain_given = 0 ;
  args_info->verbose_given = 0 ;
#define clear_args() { \
  args_info->csv_flag = 0;\
  args_info->debug_flag = 0;\
  args_info->html_flag = 0;\
  args_info->output_arg = NULL; \
  args_info->plain_flag = 0;\
  args_info->verbose_flag = 0;\
}

  clear_args();

  args_info->inputs = NULL;
  args_info->inputs_num = 0;

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "csv",	0, NULL, 'c' },
        { "debug",	0, NULL, 'd' },
        { "html",	0, NULL, 'H' },
        { "output",	1, NULL, 'o' },
        { "plain",	0, NULL, 'p' },
        { "verbose",	0, NULL, 'v' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVcdHo:pv", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          clear_args ();
          options_print_help ();
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          clear_args ();
          options_print_version ();
          exit (EXIT_SUCCESS);

        case 'c':	/* output in comma separated value format.  */
          if (args_info->csv_given)
            {
              fprintf (stderr, "%s: `--csv' (`-c') option given more than once\n", OPTIONS_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->csv_given = 1;
          args_info->csv_flag = !(args_info->csv_flag);
          break;

        case 'd':	/* scan-trace debugging.  */
          if (args_info->debug_given)
            {
              fprintf (stderr, "%s: `--debug' (`-d') option given more than once\n", OPTIONS_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->debug_given = 1;
          args_info->debug_flag = !(args_info->debug_flag);
          break;

        case 'H':	/* output in html format.  */
          if (args_info->html_given)
            {
              fprintf (stderr, "%s: `--html' (`-H') option given more than once\n", OPTIONS_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->html_given = 1;
          args_info->html_flag = !(args_info->html_flag);
          break;

        case 'o':	/* output filename.  */
          if (args_info->output_given)
            {
              fprintf (stderr, "%s: `--output' (`-o') option given more than once\n", OPTIONS_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->output_given = 1;
          args_info->output_arg = gengetopt_strdup (optarg);
          break;

        case 'p':	/* output in plain format.  */
          if (args_info->plain_given)
            {
              fprintf (stderr, "%s: `--plain' (`-p') option given more than once\n", OPTIONS_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->plain_given = 1;
          args_info->plain_flag = !(args_info->plain_flag);
          break;

        case 'v':	/* verbose operation.  */
          if (args_info->verbose_given)
            {
              fprintf (stderr, "%s: `--verbose' (`-v') option given more than once\n", OPTIONS_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->verbose_given = 1;
          args_info->verbose_flag = !(args_info->verbose_flag);
          break;


        case 0:	/* Long option with no short option */

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          exit (EXIT_FAILURE);

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c\n", OPTIONS_PACKAGE, c);
          abort ();
        } /* switch */
    } /* while */


  if ( missing_required_options )
    exit (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;
  
      args_info->inputs_num = argc - optind ;
      args_info->inputs = 
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind++]) ; 
    }
  
  return 0;
}
